#ifndef SNUVI_TYPES_H
#define SNUVI_TYPES_H

#ifdef __cplusplus
extern "C" {
#endif

#include <assert.h>
#include <limits.h>
#include <stdint.h>

typedef int8_t int8;
typedef int16_t int16;
typedef int32_t int32;
typedef int64_t int64;

typedef uint8_t uint8;
typedef uint16_t uint16;
typedef uint32_t uint32;
typedef uint64_t uint64;

typedef float float32;
static_assert(sizeof(float32) * CHAR_BIT == 32, "float is not 32 bit");

#ifdef __cplusplus
}
#endif

#endif